<?php

/**
 * Checkpoints Live plugin by Lambda
 * Completeley modified and advanced by b4card1
 * 18-07-2011, tested on PHP v5.3.5 Windows
 **/

class CPLiveAdvanced {
	
	// Config
	public $MAX_DISPLAY_ROWS = 12;
	
	public $POS_X = -64.4;
	public $POS_Y = 22.7;
	
	// In seconds
	public $INTERVAL_NICK_CHANGE = 0;
	
	public $BACKGROUND = false;
	public $INDICES = false;
	public $SPECTATORS = false;
	
	public $WHITE_NICKS_ALLOWED = true;
	public $WHITE_NICK = false;
	
	// Keys: 0 = None | 1 = F5 | 2 = F6 | 3 = F7
	public $TOGGLE_KEY = 1;
	
	// Don't modify!
	public $ID_TITLE_BAR = 1928378;
	public $ID_LIST = 1928379;
	public $ID_TOGGLE_KEY = 1928380;
	
	public $ANSWER_TOGGLE_HUD = '01928390';
	public $ANSWER_SWITCH_COLOR = '01928396';
	
	public $LOGIN_SUFFIX = '_';
	
	public $KEYS = array("No Key", "F5", "F6", "F7");
	
	public $COLORS = array("Title" => "FFE", "TrackText" => "ABC", 
		"TrackNumber" => "9B1", "Position" => "567", "CPText" => "F93", 
		"CPNumber" => "F93", "Time" => "FFC");
	
	// Fields
	private $aseco;
	
	private $players;
	private $list;
	
	private $numberCPs;
	private $lastUpdate;
	
	function init($aseco) {
		$this->aseco = $aseco;
		$this->getTrackInfo();
		
		$this->players = array();
		$this->lastUpdate = $this->getMilliSeconds();
	}
	
	function bindToggleKey($command) {
		$login = $command->login;
		$xml = '<manialink id="' . $this->ID_TOGGLE_KEY . '">';
		$xml .= '<quad action="' . $this->ANSWER_TOGGLE_HUD . '" actionkey="' . $this->TOGGLE_KEY . '" sizen="0 0"  posn="70 70 1"/>';
		$xml .= '</manialink>';
		$this->aseco->client->addCall("SendDisplayManialinkPageToLogin", array(
			$login, $xml, 0, false));
	}
	
	function manageChatCommands($command) {
		$player = $command['author'];
		$login = $player->login . $this->LOGIN_SUFFIX;
		$args = explode(' ', $command['params'], 1);
		$command = $args[0];
		
		if (!isset($command))
			return;
		
		switch ($command) {
			case "help":
				$message = '$gCurrently supported CPLive commands:' . chr(10) . ' help, color, toggle(' . $this->KEYS[$this->TOGGLE_KEY] . ')';
				$this->aseco->client->query('ChatSendToLogin', $this->aseco->formatColors($message), $player->login);
				break;
			case "color":
				$this->changeNickDisplay($login);
				break;
			case "toggle":
				$maniaLink = $this->players[$login]["Manialink"];
				if ($maniaLink)
					$this->players[$login]["Manialink"] = false;
				else
					$this->players[$login]["Manialink"] = true;
				
				$this->showListToLogin($login);
				break;
		}
	}
	
	function changeNickDisplay($login) {
		$lastUpdate = $this->players[$login]["LastNickUpdate"];
		
		if (time() - $lastUpdate >= $this->INTERVAL_NICK_CHANGE) {
			$whiteNick = $this->players[$login]["WhiteNick"];
			if ($whiteNick)
				$this->players[$login]["WhiteNick"] = false;
			else
				$this->players[$login]["WhiteNick"] = true;
			
			$this->players[$login]["LastNickUpdate"] = time();
			$this->showListToLogin($login);
		} else {
			$message = '{#error}You can change your nickname color after ' . $this->INTERVAL_NICK_CHANGE . ' second(s)!';
			$this->aseco->client->query('ChatSendToLogin', $this->aseco->formatColors($message), substr_replace($login, "", -1));
		}
	}
	
	function managePlayerConnect($command) {
		$login = $command->login . $this->LOGIN_SUFFIX;
		
		$nickname = htmlspecialchars($command->nickname);
		$nickname = $this->removeCapitals($nickname);
		$nicknameWhite = $this->removeColors($nickname);
		
		$this->aseco->client->query('GetPlayerInfo', $login, 1);
		$info = $this->aseco->client->getResponse();
		$spec = $info['SpectatorStatus'];
		
		if (is_string($login)) {
			$this->players[$login] = array("Login" => $login, 
				"NicknameWhite" => $nicknameWhite, 
				"NicknameColored" => $nickname, "Manialink" => true, 
				"WhiteNick" => $this->WHITE_NICK, "LastNickUpdate" => 0, "CPNumber" => 0, 
				"Time" => '', "Spectator" => $spec);
			
			/*Prfen, ob Nickname gesetzt wurde
			if (!in_array($nickname, $this->players[$login], true))
				unset($this->players[$login]);*/
			
			if (count($this->list) >= $this->MAX_DISPLAY_ROWS)
				$this->updateList($login);
			else
				$this->updateList("");
			
			$this->bindToggleKey($command);
		}
	}
	
	function removeCapitals($text) {
		$search = array('$t', '$w', '$o', '$i', '$s', '"', '$z');
		$replace = array("", "", "", "", "", "''", "");
		
		$newText = str_ireplace($search, $replace, $text);
		return $newText;
	}
	
	function managePlayerCheckpoint($command) {
		$login = $command[1] . $this->LOGIN_SUFFIX;
		$this->players[$login]["CPNumber"] = $command[4] + 1;
		$this->players[$login]["Time"] = $command[2];
		
		/*if (!array_key_exists($login, $this->players))
			unset($this->players[$login]);*/
		
		$this->updateList("");
	}
	
	function managePlayerFinish($command) {
		$login = $command->player->login . $this->LOGIN_SUFFIX;
		$cps = $command->challenge->nbchecks;
		
		if ($this->players[$login]["CPNumber"] != $cps) {
			$this->players[$login]["CPNumber"] = 0;
			$this->players[$login]["Time"] = '';
		}
		
		$this->updateList("");
	}
	
	function checkPlayerAnswer($command) {
		$playerLogin = $command[1];
		$login = $playerLogin . $this->LOGIN_SUFFIX;
		$answer = $command[2];
		
		switch ($answer) {
			case $this->ANSWER_TOGGLE_HUD:
				$maniaLink = $this->players[$login]["Manialink"];
				if (!$maniaLink)
					$this->players[$login]["Manialink"] = true;
				else
					$this->players[$login]["Manialink"] = false;
				
				$this->showListToLogin($login);
				break;
			case $this->ANSWER_SWITCH_COLOR:
				$this->changeNickDisplay($login);
				break;
		}
	}
	
	function checkPlayerStatus($command) {
		$login = $command["Login"] . $this->LOGIN_SUFFIX;
		$spec = $command["SpectatorStatus"];
		
		if ($spec) {
			$this->players[$login]["CPNumber"] = 0;
			$this->players[$login]["Time"] = '';
		}
		$this->players[$login]["Spectator"] = $spec;
		
		//$this->updateList("");
	}
	
	function emptyManialinks() {
		$hud = '<manialinks>';
		$hud .= '<manialink id="' . $this->ID_TITLE_BAR . '" />';
		$hud .= '<manialink id="' . $this->ID_LIST . '" />';
		$hud .= '</manialinks>';
		$this->aseco->client->query("SendDisplayManialinkPage", $hud, 1, false);
	}
	
	function reset() {
		foreach ($this->aseco->server->players->player_list as $player) {
			$login = $player->login;
			
			$this->aseco->client->query('GetPlayerInfo', $login, 1);
			$info = $this->aseco->client->getResponse();
			$spec = $info['SpectatorStatus'];
			
			$login .= $this->LOGIN_SUFFIX;
			$this->players[$login]["CPNumber"] = 0;
			$this->players[$login]["Time"] = '';
			$this->players[$login]["Spectator"] = $spec;
		}
		
		$this->getTrackInfo();
		$this->updateList("");
	}
	
	function managePlayerDisconnect($info) {
		$login = $info->login . $this->LOGIN_SUFFIX;
		unset($this->players[$login]);
		
		if (array_key_exists($login, $this->list))
			$this->updateList("");
	}
	
	function getTrackInfo() {
		$this->aseco->client->query('GetCurrentChallengeInfo');
		$info = $this->aseco->client->getResponse();
		$this->numberCPs = ($info['NbCheckpoints']) - 1;
	}
	
	function sortListBySubKey($list, $subKey) {
		// Liste auf Unterschlssel reduzieren
		foreach ($list as $key => $value) {
			$temp[$key] = strtolower($value[$subKey]);
		}
		// Temporre Liste sortieren
		arsort($temp);
		
		// Neue Liste mit sortierten Daten fllen
		foreach ($temp as $key => $value) {
			$newList[] = $list[$key];
		}
		return $newList;
	}
	
	function formatTime($ms) {
		$sec = floor($ms / 1000);
		$hun = ($ms - ($sec * 1000)) / 10;
		$min = floor($sec / 60);
		$_sec = $sec % 60;
		$time = sprintf('%02d:%02d.%02d', $min, $_sec, $hun);
		return $time;
	}
	
	function refillList() {
		$this->list = array();
		
		foreach ($this->players as $key => $player) {
			if (!$player["Spectator"] || $this->SPECTATORS)
				$this->list[$key] = $player;
		}
	
	}
	
	function updateList($login) {
		//Liste neu befllen
		$this->refillList();
		
		if (empty($this->list) == array()) {
			//Liste sortieren
			$this->list = $this->sortListBySubKey($this->list, "CPNumber");
			//Liste begrenzen
			$this->list = array_slice($this->list, 0, $this->MAX_DISPLAY_ROWS);
		}
		
		if ($login == "")
			$this->showListToAll();
		else
			$this->showListToLogin($login);
	}
	
	function getMilliSeconds() {
		$time = split(" ", microtime());
		$milliseconds = ($time[1] . substr($time[0], 1)) * 1000;
		return $milliseconds;
	}
	
	function showListToAll() {
		$time = $this->getMilliSeconds();
		if (($time - $this->lastUpdate) < 400)
			return;
		
		foreach ($this->players as $login => $player) {
			if ($player["Manialink"])
				$this->showList($login);
		}
		$this->lastUpdate = $this->getMilliSeconds();
	}
	
	function showListToLogin($login) {
		if ($this->players[$login]["Manialink"])
			$this->showList($login);
		else
			$this->hideList($login);
	}
	
	function displayTitleBar($login) {
		$hud = '<?xml version="1.0" encoding="UTF-8"?>';
		$hud .= '<manialink id="' . $this->ID_TITLE_BAR . '">';
		$hud .= '<frame scale="1" posn="' . $this->POS_X . ' ' . $this->POS_Y . '">';
		$hud .= '<quad posn="0 0 0" sizen="21 2 0.08" halign="left" valign="center" style="BgsPlayerCard" substyle="BgCard" action="' . $this->ANSWER_SWITCH_COLOR . '"/>';
		$hud .= '<label scale="0.45" posn="0.4 0.1 0.1" halign="left" valign="center" style="TextRaceMessage" text="$' . $this->COLORS['Title'] . ' Checkpoints Live"/>';
		$hud .= '<label scale="0.45" posn="11 0.1 0.1" halign="left" valign="center" style="TextRaceMessage" text="$' . $this->COLORS['TrackText'] . 'Track CPs:"/>';
		$hud .= '<label scale="0.45" posn="17.5 0.1 0.1" halign="center" valign="center" style="TextRaceMessage" text="$' . $this->COLORS['TrackNumber'] . '' . $this->numberCPs . '"/>';
		$hud .= '<quad posn="19 0 0.12" sizen="1.8 1.8" halign="left" valign="center"
				image="http://www.imageshare.web.id/images/08y0yvg4k23h26gbbmg2.png"
				imagefocus="http://www.imageshare.web.id/images/v69z1j9sd9ebkgj9sckf.png" action="' . $this->ANSWER_TOGGLE_HUD . '"/>';
		$hud .= '</frame>';
		$hud .= '</manialink>';
		$this->aseco->client->query("SendDisplayManialinkPageToLogin", substr_replace($login, "", -1), $hud, 0, false);
	}
	
	function showList($login) {
		$this->displayTitleBar($login);
		
		$hud = '<manialink id="' . $this->ID_LIST . '">';
		
		$y = $this->POS_Y - 1.9;
		$pos = 1;
		
		foreach ($this->list as $player) {
			if ($this->WHITE_NICKS_ALLOWED && $this->players[$login]["WhiteNick"])
				$nickname = $player["NicknameWhite"];
			else
				$nickname = $player["NicknameColored"];
			
			$hud .= '<frame scale="1" posn="' . $this->POS_X . ' ' . $y . '">';
			
			if ($this->INDICES)
				$hud .= '<label scale="0.48" posn="0.3 0.1 0.1" halign="left" valign="center" style="TextRaceMessage" text="$' . $this->COLORS['Position'] . '' . str_pad($pos, 2, '0', STR_PAD_LEFT) . '"/>';
			
			if (($player["CPNumber"] - 1) == $this->numberCPs) {
				$hud .= '<label scale="0.48" posn="1.8 0.1 0.1" halign="left" valign="center" style="TextRaceMessage" text="$' . $this->COLORS['CPText'] . 'CP-"/>';
				$hud .= '<quad posn="4 0 0" sizen="1.6 1.6" halign="left" valign="center" style="BgRaceScore2" substyle="Warmup"/>';
			} else {
				$hud .= '<label scale="0.48" posn="1.8 0.1 0.1" halign="left" valign="center" style="TextRaceMessage" text="$' . $this->COLORS['CPText'] . 'CP-$' . $this->COLORS['CPNumber'] . '' . $player["CPNumber"] . '"/>';
			}
			
			$hud .= '<label scale="0.48" posn="10.4 0.1 0.1" halign="right" valign="center" style="TextRaceMessage" text="$' . $this->COLORS['Time'] . '' . $this->formatTime($player["Time"]) . '"/>';
			$hud .= '<label scale="0.48" posn="10.6 0.1 0.1" sizen="21 2" halign="left" valign="center" style="TextRaceMessage" text="' . $nickname . '"/>';
			$hud .= '</frame>';
			
			$y -= 1.8;
			$pos++;
		}
		
		if ($this->BACKGROUND) {
			$rows = count($this->list);
			$qheight = ($rows * 1.8) + 0.6;
			$hud .= '<quad posn="' . $this->POS_X . ' ' . ($this->POS_Y - 0.7) . '" sizen="21 ' . $qheight . ' 0.08" halign="left" valign="top" style="Bgs1InRace" substyle="NavButton"/>';
		}
		
		$hud .= '</manialink>';
		$this->aseco->client->query("SendDisplayManialinkPageToLogin", substr_replace($login, "", -1), $hud, 0, false);
	}
	
	function removeColors($nickname) {
		$colorCodes = array('0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 
			'a', 'b', 'c', 'd', 'e', 'f', 'A', 'B', 'C', 'D', 'E', 'F');
		
		$newNickname = "";
		for ($i = 0; $i < strlen($nickname); $i++) {
			$char = substr($nickname, $i, 1);
			if ($char == "$") {
				$charNext = substr($nickname, $i + 1, 1);
				$colorCode = false;
				
				for ($j = 0; $j < count($colorCodes); $j++) {
					if ($charNext == $colorCodes[$j]) {
						$colorCode = true;
						$i += 3;
						break;
					}
				}
				
				if (!$colorCode)
					$newNickname .= $char;
			} else
				$newNickname .= $char;
		}
		return $newNickname;
	}
	
	function hideList($login) {
		$hud = '</manialinks>';
		$hud .= '<manialink id="' . $this->ID_TITLE_BAR . '">';
		$hud .= '<frame scale="1" posn="' . $this->POS_X . ' ' . $this->POS_Y . '">';
		$hud .= '<quad posn="0 0 0" sizen="6.8 2 0.08" halign="left" valign="center" style="BgsPlayerCard" substyle="BgCard" />';
		$hud .= '<label scale="0.45" posn="0.4 0.1 0.1" halign="left" valign="center" style="TextRaceMessage" text="$' . $this->COLORS['Title'] . ' CP Live"/>';
		$hud .= '<quad posn="4.9 0 0.12" sizen="1.8 1.8 " halign="left" valign="center" image="http://www.imageshare.web.id/images/q7xwtmnuxbrble2eow3h.png" imagefocus="http://www.imageshare.web.id/images/hb2te8udrnlm03yo6yy2.png" action="' . $this->ANSWER_TOGGLE_HUD . '"/>';
		$hud .= '</frame>';
		$hud .= '</manialink>';
		$hud .= '<manialink id="' . $this->ID_LIST . '" />';
		$hud .= '</manialinks>';
		$this->aseco->client->query("SendDisplayManialinkPageToLogin", substr_replace($login, "", -1), $hud, 0, false);
	}
}

// Aseco
global $cpLive;
$cpLive = new CPLiveAdvanced();

Aseco::registerEvent('onSync', 'cpLive_onSync');
function cpLive_onSync($aseco) {
	global $cpLive;
	$cpLive = new CPLiveAdvanced();
	$cpLive->init($aseco);
}

Aseco::registerEvent('onRestartChallenge', 'cpLive_onRestartChallenge');
function cpLive_onRestartChallenge($aseco) {
	global $cpLive;
	$cpLive->emptyManialinks();
}

Aseco::registerEvent('onPlayerConnect', 'cpLive_onPlayerConnect');
function cpLive_onPlayerConnect($aseco, $command) {
	global $cpLive;
	$cpLive->managePlayerConnect($command);
}

Aseco::registerEvent('onCheckpoint', 'cpLive_onCheckpoint');
function cpLive_onCheckpoint($aseco, $command) {
	global $cpLive;
	$cpLive->managePlayerCheckpoint($command);
}

Aseco::registerEvent('onPlayerFinish', 'cpLive_onPlayerFinish');
function cpLive_onPlayerFinish($aseco, $command) {
	global $cpLive;
	$cpLive->managePlayerFinish($command);
}

Aseco::registerEvent('onPlayerManialinkPageAnswer', 'cpLive_onPlayerManialinkPageAnswer');
function cpLive_onPlayerManialinkPageAnswer($aseco, $command) {
	global $cpLive;
	$cpLive->checkPlayerAnswer($command);
}

Aseco::registerEvent('onPlayerInfoChanged', 'cpLive_onPlayerInfoChanged');
function cpLive_onPlayerInfoChanged($aseco, $command) {
	global $cpLive;
	$cpLive->checkPlayerStatus($command);
}

Aseco::registerEvent('onEndRound', 'cpLive_onEndRound');
function cpLive_onEndRound($aseco) {
	global $cpLive;
	$cpLive->emptyManialinks();
}

Aseco::registerEvent('onBeginRound', 'cpLive_onBeginRound');
function cpLive_onBeginRound($aseco) {
	global $cpLive;
	$cpLive->reset();
}

Aseco::registerEvent('onPlayerDisconnect', 'cpLive_onPlayerDisconnect');
function cpLive_onPlayerDisconnect($aseco, $info) {
	global $cpLive;
	$cpLive->managePlayerDisconnect($info);
}

Aseco::addChatCommand('cpLive', 'CPLive chat commands: help, color, toggle(' . $cpLive->KEYS[$cpLive->TOGGLE_KEY] . ')');
function chat_cpLive($aseco, $command) {
	global $cpLive;
	$cpLive->manageChatCommands($command);
}

?>